#include <cstdio>

int solve();

int main () {
  int p;
  for (scanf("%d",&p);p;p--) printf("%d\n",solve());
  return 0;
}

int solve() {
/*
          -   (Xct>n/2)
     .  - Xct < n/2 ->   .
         ,  
          (    ) 
          :

  Xct = sum(x[i]*s[i])/sum(s[i])   (1)
  :
    x[i] - x       i-   -
    s[i] -   i- 

         ()   :
              ,
      ->   ->   ->   -> ..  ;-)

             ,  
    -  .   , :
    x[i]*s[i] = (x+a/2)*a*a        (2)   
    x[i]*s[i] = (x+a/3)*a*a/2      (3)     1  2
    x[i]*s[i] = (x-a/3)*a*a/2      (4)     3  4
  :
    x - x      

   (1), (2)  (3)   - :
    x[i]*s[i] = (x+a/2)*a*a   = (6*x+3*a)*a*a/6 = F[]**/6          (2')
    x[i]*s[i] = (x+a/3)*a*a/2 = (3*x+a)*a*a/6   = F[]*a*a/6    (3')
    x[i]*s[i] = (x-a/3)*a*a/2 = (3*x-a)*a*a/6   = F[]*a*a/6  (4')

     (1)  :
    (m*n)*n/2 - a*a/6 * sum(F[i])           (F[i] -   i- .  -)

     (1)  :
    (m*n) - q*a*a - t*a*a/2  = (m*n) - (2*q+t)*a*a/2
  :
    q -    
    t -    

    Xct > n/2 ( Xct = n/2  Xct < n/2)
     ,    (    !!!)
  :
    ------------------------------------------------------------
    3*(2*q+t)*n > 2*sum(F[i]) ->    
    3*(2*q+t)*n = 2*sum(F[i]) ->    
    3*(2*q+t)*n < 2*sum(F[i]) ->    
    ------------------------------------------------------------
*/

  int m, n, a, k, q=0, t=0, x, y, c;
  long long leftside, righteside=0;
  scanf("%d %d %d %d", &m, &n, &a, &k);
  for (;k;k--) {
    scanf("%d %d %d",&c,&x,&y);
    switch (c) {
      case 0: ++q, righteside+=(6*x+3*a);break;
      case 1: case 2: ++t, righteside+=(3*x+a);break;
      case 3: case 4: ++t, righteside+=(3*x-a);
    }
  }
  leftside=(long long)3 * n * (2*q+t);
  righteside*=2;
  return (leftside>righteside?1:(leftside<righteside?-1:0));
}
