#include <cstdio>
#include <cmath>
using namespace std;

void solve ()
{
	int i, orient, a, k, x, y, n, m;
	double s=0.0, center=0.0;

	scanf ("%d%d%d%d", &m, &n, &a, &k);

	for (i=0; i<k; i++) {
		scanf ("%d%d%d", &orient, &x, &y);

		if (orient==0) {
			center+=(x+a/2.0-n/2.0)*a*a;
		} else if (orient==1 || orient==2) {
			center+=(x+a/3.0-n/2.0)*a*a/2.0;
		} else {
			center+=(x-a/3.0-n/2.0)*a*a/2.0;
		}
	}
	
	if (fabs(center) < 1e-6) printf ("0\n");
	else printf ("%d\n", center > 0.0 ? -1 : 1);
}

int main ()
{
	freopen ("dbig.in", "r", stdin);
	freopen ("dbig.out", "w", stdout);

	int t;

	scanf ("%d", &t);
	while (t--)
		solve ();

	return 0;
}